;
; Startup code for cc65 (Vic20 version)
;

        .export         _exit
        .export         __STARTUP__ : absolute = 1      ; Mark as startup
        .import         initlib, donelib
        .import         zerobss, push0, _main
        ;.import         callmain
        .import         RESTOR, BSOUT, CLRCH
        .import         __MAIN_START__, __MAIN_SIZE__   ; Linker generated
        .import         __STACKSIZE__                   ; Linker generated
        .importzp       ST

	.exportzp	_curmptr, _mpos, _cate, _cursto, _i, _j, _c
	.exportzp	_curout, _k, _spc, _CurPos, _atpos

        .include        "zeropage.inc"
        .include        "vic20.inc"

; ------------------------------------------------------------------------
; Startup code

.segment        "STARTUP"

Start:

; Save the zero-page locations that we need.

; Switch to the second charset.

        lda     #14
        jsr     BSOUT

; Clear the BSS data.

        ;jsr     zerobss

; Save some system stuff; and, set up the stack.

        ;tsx
        ;stx     spsave          ; Save the system stack ptr

        lda     #<(__MAIN_START__ + __MAIN_SIZE__ + __STACKSIZE__)
        ldx     #>(__MAIN_START__ + __MAIN_SIZE__ + __STACKSIZE__)
        sta     sp
        stx     sp+1            ; Set argument stack ptr

; Call the module constructors.

        ;jsr     initlib

; Push the command-line arguments; and, call main().

        ;jsr     callmain
	;jsr	push0
	;jsr	push0
	jsr	_main

; Back from main() [this is also the exit() entry]. Run the module destructors.

_exit:  			; Save the return code on stack
        ;jsr     donelib

; Back to BASIC.

        ;rts
	jmp	($FFFC)

; ------------------------------------------------------------------------

.segment        "INIT"

;zpsave: .res    zpspace

; ------------------------------------------------------------------------

.segment	"BUF1H"
.word	$200

.segment	"BUF2H"
.word	$2A1

.segment	"BUF3H"
.word	$334

.segment	"BUF4H"
.word	$0032

.zeropage
_curmptr:	.res	2
_mpos:		.res	2
_cate:		.res	1
_cursto:	.res	1
_i:		.res	2
_j:		.res	2
_curptr:	.res	2
_c:		.res	1
_curout:	.res	2
_k:		.res	2
_spc:		.res	1
_CurPos:	.res	1
_atpos:		.res	2
